#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Jun 19 18:50:58 2017

@author: thiago
"""

from arvores import NoArvoreBinaria
from treeview import mostra_arvores

class NoArvoreAVL(NoArvoreBinaria):
    class _NoNulo(NoArvoreBinaria._NoNulo):
        def insere(self, x):
            return NoArvoreAVL(x)
        _altura = 0
    
    ArvoreVazia = _NoNulo()
    
    def __init__(self, x, e = ArvoreVazia, d = ArvoreVazia):
        super(NoArvoreAVL, self).__init__(x, e, d)
        self._altura = 1 + max(self._e._altura, self._d._altura) 
        
    def _gira_esquerda(self):
        b = self._d
        m = b._e
        self._d = m
        self._altura = max(self._e._altura, m._altura)+1
        b._e = self
        b._altura = max(b._e._altura, b._d._altura)+1
        return b

    def _gira_direita(self):
        b = self._e
        m = b._d
        self._e = m
        self._altura = max(self._d._altura, m._altura)+1
        b._d = self
        b._altura = max(b._e._altura, b._d._altura)+1
        return b
    
    def insere(self, x):
        if x>self._x:
            self._d = self._d.insere(x)
            if self._d._altura > self._e._altura + 1:
                # Insercao desbalanceou: realinha
                if self._d._e._altura > self._d._d._altura:
                   self._d = self._d._gira_direita()
                ret = self._gira_esquerda()
            else:
                ret = self
                # Recalcula altura
                if self._d._altura > self._e._altura:
                    self._altura = self._d._altura + 1
        elif x<self._x:
            self._e = self._e.insere(x)
            if self._e._altura > self._d._altura + 1:
                # Insercao desbalanceou: realinha
                if self._e._d._altura > self._e._e._altura:
                   self._e = self._e._gira_esquerda()
                ret = self._gira_direita()
            else:
                ret = self
                if self._e._altura > self._d._altura:
                    self._altura = self._e._altura + 1
        else:
            raise Exception("Elemento ja existe")
        return ret
    
    def remove(self, x):
        if x == self._x:
            if not self._e:
                return self._d
            elif not self._d:
                return self._e 
            #  Procura pelo menor elemento da arvore direita
            a = self._d
            while a._e: a = a._e
            a._x, self._x = self._x, a._x
            self._d = self._d.remove(x)
        elif x > self._x:
            self._d = self._d.remove(x)               
        elif x < self._x:
            self._e = self._e.remove(x)
            if self._d._altura > self._e._altura + 1:
                # Desbalanco a direita
                if self._d._e._altura > self._d._d._altura:
                    self._d = self._d._gira_direita()
                return self._gira_esquerda()
            else:
                if self._d._altura > self._e._altura:
                    self._altura = self._d._altura + 1
                return self
        # Chega-se aqui por uma remoção à direita
        if self._e._altura > self._d._altura + 1:
            # Desbalanco a esquerda
            if self._e._d._altura > self._e._e._altura:
                self._e = self._e._gira_esquerda()
            return self._gira_direita()
        else: # So recalcula altura
            if self._e._altura > self._d._altura:
                self._altura = self._e._altura + 1
            return self
